//+------------------------------------------------------------------+
//|                                            MetroPitchfork_v2.mq4 |
//|                                                            Talex |
//|                                                 tan@gazinter.net |
//+------------------------------------------------------------------+
#property copyright "Talex"
#property link      "tan@gazinter.net"

#property indicator_chart_window
#import "user32.dll"
int GetClientRect(int hWnd,int lpRect[]);
#import

extern string txt1 = " ---   ---";
extern int ExtPoint=3; /*    ,    3,        */
extern double Scale=0; //     .
extern string ExtComplect="0"; /*   ,      */
extern bool ExtSave=false; /*  true,       */
extern string txt2 = " ---   ---";
extern int ExtArcStyle=0; /*     */ 
extern int ExtArcWidth=1; /*     */
extern color ExtArcColor=Red; /*   */
extern string txt3 = " ---   1 ---";
extern bool Channel1=false; /* true -    1 */
extern int ExtChannelStyle1=0; /*     1 */ 
extern int ExtChannelWidth1=1; /*     1 */
extern color ExtChannelColor1=Lime; /*   1 */
extern string txt4 = " ---   2 ---";
extern bool Channel2=false; /* true -    2 */
extern int ExtChannelStyle2=0; /*     2 */ 
extern int ExtChannelWidth2=2; /*     2 */
extern color ExtChannelColor2=Blue; /*   2 */

//extern int MetodScale=1; //  Scale=0,   

extern string txt5 = " ---   ZigZag ---";
extern int ExtDepth = 26;
extern int ExtDeviation = 5;
extern int ExtBackstep = 3;
extern string txt6 = " ---  ---";
extern double Fibo1=0.0;
extern double Fibo2=0.382;
extern double Fibo3=0.5;
extern double Fibo4=0.618;
extern double Fibo5=0.786;
extern double Fibo6=0.886;
extern double Fibo7=1.0;
extern double Fibo8=1.272;
extern double Fibo9=1.618;
extern double Fibo10=2.0;
extern double Fibo11=2.618;

static int GPixels,VPixels;
int rect[4],hwnd;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
   hwnd=WindowHandle(Symbol(),Period());
   if(hwnd>0)
   {
     GetClientRect(hwnd,rect);
     GPixels=rect[2]; //    -   
     VPixels=rect[3]; //    -   
   }
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   ObjectDelete("MetroPitchfork"+"_"+ExtComplect+"_");
   ObjectDelete("MetroArc"+"_"+ExtComplect+"_");
   ObjectDelete("MetroChannel1"+"_"+ExtComplect+"_");
   ObjectDelete("MetroChannel2"+"_"+ExtComplect+"_");
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   int i,j,zzbar[];
   double zz,zzp[],tp,k,b,medpr;
   datetime medtm,newbar;
   string save="";
//----
   if(newbar!=Time[0])
   {
     newbar=Time[0];
     ArrayResize(zzbar,ExtPoint); 
     ArrayResize(zzp,ExtPoint); 
   
   if(ExtSave==true)
   {
    save=TimeToStr(TimeLocal(),TIME_DATE|TIME_SECONDS);
   }
//   
     for(i=0,j=0;i<Bars && j<ExtPoint;i++)
     {
       zz=iCustom(NULL,0,"ZigZag",ExtDepth,ExtDeviation,ExtBackstep,0,i);
       if(zz!=0)
       {
         zzbar[j]=i;
         zzp[j]=zz;
         j++;
       }
     }
//    
     medpr=zzp[ExtPoint-3]+zzp[ExtPoint-2]-zzp[ExtPoint-1];

     if(zzbar[ExtPoint-3]-(zzbar[ExtPoint-1]-zzbar[ExtPoint-2])<0)
     {
       medtm=Time[0]+(zzbar[ExtPoint-1]-zzbar[ExtPoint-2]-zzbar[ExtPoint-3])*Period()*60;
     }else medtm=Time[zzbar[ExtPoint-3]-(zzbar[ExtPoint-1]-zzbar[ExtPoint-2])];

//        
     k=(zzp[ExtPoint-1]-medpr)/(Time[zzbar[ExtPoint-1]]-medtm); 
     b=medpr-k*medtm;       
     tp=NormalizeDouble(k*Time[zzbar[ExtPoint-3]]+b,Digits);

//  
     if(Scale==0)
     {
       Scale=Scale();
     }
     ObjectCreate("MetroPitchfork"+"_"+ExtComplect+"_"+save,OBJ_PITCHFORK,0,Time[zzbar[ExtPoint-2]],zzp[ExtPoint-2],Time[zzbar[ExtPoint-3]],zzp[ExtPoint-3],Time[zzbar[ExtPoint-3]],2*tp-zzp[ExtPoint-3]);
     ObjectCreate("MetroArc"+"_"+ExtComplect+"_"+save,OBJ_FIBOARC,0,Time[zzbar[ExtPoint-3]],zzp[ExtPoint-3],Time[zzbar[ExtPoint-3]],tp);
     ObjectSet("MetroArc"+"_"+ExtComplect+"_"+save,OBJPROP_ELLIPSE,true);
     ObjectSet("MetroArc"+"_"+ExtComplect+"_"+save,OBJPROP_SCALE,Scale);
     ObjectSet("MetroArc"+"_"+ExtComplect+"_"+save,OBJPROP_FIBOLEVELS,4);
     ObjectSet("MetroArc"+"_"+ExtComplect+"_"+save,OBJPROP_FIRSTLEVEL+0,0.382);
     ObjectSet("MetroArc"+"_"+ExtComplect+"_"+save,OBJPROP_FIRSTLEVEL+1,0.5);
     ObjectSet("MetroArc"+"_"+ExtComplect+"_"+save,OBJPROP_FIRSTLEVEL+2,0.618);
     ObjectSet("MetroArc"+"_"+ExtComplect+"_"+save,OBJPROP_FIRSTLEVEL+3,1.0);
     ObjectSet("MetroArc"+"_"+ExtComplect+"_"+save,OBJPROP_LEVELCOLOR,ExtArcColor);
     ObjectSet("MetroArc"+"_"+ExtComplect+"_"+save,OBJPROP_LEVELSTYLE,ExtArcStyle);
     ObjectSet("MetroArc"+"_"+ExtComplect+"_"+save,OBJPROP_LEVELWIDTH,ExtArcWidth);
     if(Channel1)
     {
       ObjectCreate("MetroChannel1"+"_"+ExtComplect+"_"+save,OBJ_FIBOCHANNEL,0,Time[2*zzbar[ExtPoint-2]-zzbar[ExtPoint-3]],2*zzp[ExtPoint-2]-2*tp+zzp[ExtPoint-3],Time[zzbar[ExtPoint-2]],2*zzp[ExtPoint-3]+zzp[ExtPoint-2]-2*tp,Time[zzbar[ExtPoint-2]],zzp[ExtPoint-2]);
       ObjectSet("MetroChannel1"+"_"+ExtComplect+"_"+save,OBJPROP_COLOR,ExtChannelColor1);
       ObjectSet("MetroChannel1"+"_"+ExtComplect+"_"+save,OBJPROP_STYLE,ExtChannelStyle1);
       ObjectSet("MetroChannel1"+"_"+ExtComplect+"_"+save,OBJPROP_WIDTH,ExtChannelWidth1);
       ObjectSet("MetroChannel1"+"_"+ExtComplect+"_"+save,OBJPROP_FIBOLEVELS,22);
       ObjectSet("MetroChannel1"+"_"+ExtComplect+"_"+save,OBJPROP_LEVELCOLOR,ExtChannelColor1);
       ObjectSet("MetroChannel1"+"_"+ExtComplect+"_"+save,OBJPROP_LEVELSTYLE,ExtChannelStyle1);
       ObjectSet("MetroChannel1"+"_"+ExtComplect+"_"+save,OBJPROP_LEVELWIDTH,ExtChannelWidth1);
       ObjectSet("MetroChannel1"+"_"+ExtComplect+"_"+save,OBJPROP_FIRSTLEVEL+0,Fibo1);
       ObjectSet("MetroChannel1"+"_"+ExtComplect+"_"+save,OBJPROP_FIRSTLEVEL+1,Fibo2);
       ObjectSet("MetroChannel1"+"_"+ExtComplect+"_"+save,OBJPROP_FIRSTLEVEL+2,Fibo3);
       ObjectSet("MetroChannel1"+"_"+ExtComplect+"_"+save,OBJPROP_FIRSTLEVEL+3,Fibo4);
       ObjectSet("MetroChannel1"+"_"+ExtComplect+"_"+save,OBJPROP_FIRSTLEVEL+4,Fibo5);
       ObjectSet("MetroChannel1"+"_"+ExtComplect+"_"+save,OBJPROP_FIRSTLEVEL+5,Fibo6);
       ObjectSet("MetroChannel1"+"_"+ExtComplect+"_"+save,OBJPROP_FIRSTLEVEL+6,Fibo7);
       ObjectSet("MetroChannel1"+"_"+ExtComplect+"_"+save,OBJPROP_FIRSTLEVEL+7,Fibo8);
       ObjectSet("MetroChannel1"+"_"+ExtComplect+"_"+save,OBJPROP_FIRSTLEVEL+8,Fibo9);
       ObjectSet("MetroChannel1"+"_"+ExtComplect+"_"+save,OBJPROP_FIRSTLEVEL+9,Fibo10);
       ObjectSet("MetroChannel1"+"_"+ExtComplect+"_"+save,OBJPROP_FIRSTLEVEL+10,Fibo11);
       //ObjectSet("MetroChannel1"+"_"+ExtComplect+"_"+save,OBJPROP_FIRSTLEVEL+11,-Fibo1);
       //ObjectSet("MetroChannel1"+"_"+ExtComplect+"_"+save,OBJPROP_FIRSTLEVEL+12,-Fibo2);
       //ObjectSet("MetroChannel1"+"_"+ExtComplect+"_"+save,OBJPROP_FIRSTLEVEL+13,-Fibo3);
       //ObjectSet("MetroChannel1"+"_"+ExtComplect+"_"+save,OBJPROP_FIRSTLEVEL+14,-Fibo4);
       //ObjectSet("MetroChannel1"+"_"+ExtComplect+"_"+save,OBJPROP_FIRSTLEVEL+15,-Fibo5);
       //ObjectSet("MetroChannel1"+"_"+ExtComplect+"_"+save,OBJPROP_FIRSTLEVEL+16,-Fibo6);
       //ObjectSet("MetroChannel1"+"_"+ExtComplect+"_"+save,OBJPROP_FIRSTLEVEL+17,-Fibo7);
       //ObjectSet("MetroChannel1"+"_"+ExtComplect+"_"+save,OBJPROP_FIRSTLEVEL+18,-Fibo8);
       //ObjectSet("MetroChannel1"+"_"+ExtComplect+"_"+save,OBJPROP_FIRSTLEVEL+19,-Fibo9);
       //ObjectSet("MetroChannel1"+"_"+ExtComplect+"_"+save,OBJPROP_FIRSTLEVEL+20,-Fibo10);
       //ObjectSet("MetroChannel1"+"_"+ExtComplect+"_"+save,OBJPROP_FIRSTLEVEL+21,-Fibo11);
       ObjectSetFiboDescription("MetroChannel1"+"_"+ExtComplect+"_"+save,0,DoubleToStr(Fibo1*100,1));
       ObjectSetFiboDescription("MetroChannel1"+"_"+ExtComplect+"_"+save,1,DoubleToStr(Fibo2*100,1));
       ObjectSetFiboDescription("MetroChannel1"+"_"+ExtComplect+"_"+save,2,DoubleToStr(Fibo3*100,1));
       ObjectSetFiboDescription("MetroChannel1"+"_"+ExtComplect+"_"+save,3,DoubleToStr(Fibo4*100,1));
       ObjectSetFiboDescription("MetroChannel1"+"_"+ExtComplect+"_"+save,4,DoubleToStr(Fibo5*100,1));
       ObjectSetFiboDescription("MetroChannel1"+"_"+ExtComplect+"_"+save,5,DoubleToStr(Fibo6*100,1));
       ObjectSetFiboDescription("MetroChannel1"+"_"+ExtComplect+"_"+save,6,DoubleToStr(Fibo7*100,1));
       ObjectSetFiboDescription("MetroChannel1"+"_"+ExtComplect+"_"+save,7,DoubleToStr(Fibo8*100,1));
       ObjectSetFiboDescription("MetroChannel1"+"_"+ExtComplect+"_"+save,8,DoubleToStr(Fibo9*100,1));
       ObjectSetFiboDescription("MetroChannel1"+"_"+ExtComplect+"_"+save,9,DoubleToStr(Fibo10*100,1));
       ObjectSetFiboDescription("MetroChannel1"+"_"+ExtComplect+"_"+save,10,DoubleToStr(Fibo11*100,1));
       //ObjectSetFiboDescription("MetroChannel1"+"_"+ExtComplect+"_"+save,11,"-"+DoubleToStr(Fibo1*100,1));
       //ObjectSetFiboDescription("MetroChannel1"+"_"+ExtComplect+"_"+save,12,"-"+DoubleToStr(Fibo2*100,1));
       //ObjectSetFiboDescription("MetroChannel1"+"_"+ExtComplect+"_"+save,13,"-"+DoubleToStr(Fibo3*100,1));
       //ObjectSetFiboDescription("MetroChannel1"+"_"+ExtComplect+"_"+save,14,"-"+DoubleToStr(Fibo4*100,1));
       //ObjectSetFiboDescription("MetroChannel1"+"_"+ExtComplect+"_"+save,15,"-"+DoubleToStr(Fibo5*100,1));
       //ObjectSetFiboDescription("MetroChannel1"+"_"+ExtComplect+"_"+save,16,"-"+DoubleToStr(Fibo6*100,1));
       //ObjectSetFiboDescription("MetroChannel1"+"_"+ExtComplect+"_"+save,17,"-"+DoubleToStr(Fibo7*100,1));
       //ObjectSetFiboDescription("MetroChannel1"+"_"+ExtComplect+"_"+save,18,"-"+DoubleToStr(Fibo8*100,1));
       //ObjectSetFiboDescription("MetroChannel1"+"_"+ExtComplect+"_"+save,19,"-"+DoubleToStr(Fibo9*100,1));
       //ObjectSetFiboDescription("MetroChannel1"+"_"+ExtComplect+"_"+save,20,"-"+DoubleToStr(Fibo10*100,1));
       //ObjectSetFiboDescription("MetroChannel1"+"_"+ExtComplect+"_"+save,21,"-"+DoubleToStr(Fibo11*100,1));
     }
     if(Channel2)
     {
       ObjectCreate("MetroChannel2"+"_"+ExtComplect+"_"+save,OBJ_FIBOCHANNEL,0,Time[2*zzbar[ExtPoint-2]-zzbar[ExtPoint-3]],2*zzp[ExtPoint-2]-zzp[ExtPoint-3],Time[zzbar[ExtPoint-2]],2*tp-2*zzp[ExtPoint-3]+zzp[ExtPoint-2],Time[zzbar[ExtPoint-2]],zzp[ExtPoint-2]);
       ObjectSet("MetroChannel2"+"_"+ExtComplect+"_"+save,OBJPROP_COLOR,ExtChannelColor2);
       ObjectSet("MetroChannel2"+"_"+ExtComplect+"_"+save,OBJPROP_STYLE,ExtChannelStyle2);
       ObjectSet("MetroChannel2"+"_"+ExtComplect+"_"+save,OBJPROP_WIDTH,ExtChannelWidth2);
       ObjectSet("MetroChannel2"+"_"+ExtComplect+"_"+save,OBJPROP_FIBOLEVELS,22);
       ObjectSet("MetroChannel2"+"_"+ExtComplect+"_"+save,OBJPROP_LEVELCOLOR,ExtChannelColor2);
       ObjectSet("MetroChannel2"+"_"+ExtComplect+"_"+save,OBJPROP_LEVELSTYLE,ExtChannelStyle2);
       ObjectSet("MetroChannel2"+"_"+ExtComplect+"_"+save,OBJPROP_LEVELWIDTH,ExtChannelWidth2);
       ObjectSet("MetroChannel2"+"_"+ExtComplect+"_"+save,OBJPROP_FIRSTLEVEL+0,Fibo1);
       ObjectSet("MetroChannel2"+"_"+ExtComplect+"_"+save,OBJPROP_FIRSTLEVEL+0,Fibo1);
       ObjectSet("MetroChannel2"+"_"+ExtComplect+"_"+save,OBJPROP_FIRSTLEVEL+1,Fibo2);
       ObjectSet("MetroChannel2"+"_"+ExtComplect+"_"+save,OBJPROP_FIRSTLEVEL+2,Fibo3);
       ObjectSet("MetroChannel2"+"_"+ExtComplect+"_"+save,OBJPROP_FIRSTLEVEL+3,Fibo4);
       ObjectSet("MetroChannel2"+"_"+ExtComplect+"_"+save,OBJPROP_FIRSTLEVEL+4,Fibo5);
       ObjectSet("MetroChannel2"+"_"+ExtComplect+"_"+save,OBJPROP_FIRSTLEVEL+5,Fibo6);
       ObjectSet("MetroChannel2"+"_"+ExtComplect+"_"+save,OBJPROP_FIRSTLEVEL+6,Fibo7);
       ObjectSet("MetroChannel2"+"_"+ExtComplect+"_"+save,OBJPROP_FIRSTLEVEL+7,Fibo8);
       ObjectSet("MetroChannel2"+"_"+ExtComplect+"_"+save,OBJPROP_FIRSTLEVEL+8,Fibo9);
       ObjectSet("MetroChannel2"+"_"+ExtComplect+"_"+save,OBJPROP_FIRSTLEVEL+9,Fibo10);
       ObjectSet("MetroChannel2"+"_"+ExtComplect+"_"+save,OBJPROP_FIRSTLEVEL+10,Fibo11);
       //ObjectSet("MetroChannel2"+"_"+ExtComplect+"_"+save,OBJPROP_FIRSTLEVEL+11,-Fibo1);
       //ObjectSet("MetroChannel2"+"_"+ExtComplect+"_"+save,OBJPROP_FIRSTLEVEL+12,-Fibo2);
       //ObjectSet("MetroChannel2"+"_"+ExtComplect+"_"+save,OBJPROP_FIRSTLEVEL+13,-Fibo3);
       //ObjectSet("MetroChannel2"+"_"+ExtComplect+"_"+save,OBJPROP_FIRSTLEVEL+14,-Fibo4);
       //ObjectSet("MetroChannel2"+"_"+ExtComplect+"_"+save,OBJPROP_FIRSTLEVEL+15,-Fibo5);
       //ObjectSet("MetroChannel2"+"_"+ExtComplect+"_"+save,OBJPROP_FIRSTLEVEL+16,-Fibo6);
       //ObjectSet("MetroChannel2"+"_"+ExtComplect+"_"+save,OBJPROP_FIRSTLEVEL+17,-Fibo7);
       //ObjectSet("MetroChannel2"+"_"+ExtComplect+"_"+save,OBJPROP_FIRSTLEVEL+18,-Fibo8);
       //ObjectSet("MetroChannel2"+"_"+ExtComplect+"_"+save,OBJPROP_FIRSTLEVEL+19,-Fibo9);
       //ObjectSet("MetroChannel2"+"_"+ExtComplect+"_"+save,OBJPROP_FIRSTLEVEL+20,-Fibo10);
       //ObjectSet("MetroChannel2"+"_"+ExtComplect+"_"+save,OBJPROP_FIRSTLEVEL+21,-Fibo11);
       ObjectSetFiboDescription("MetroChannel2"+"_"+ExtComplect+"_"+save,0,DoubleToStr(Fibo1*100,1));
       ObjectSetFiboDescription("MetroChannel2"+"_"+ExtComplect+"_"+save,1,DoubleToStr(Fibo2*100,1));
       ObjectSetFiboDescription("MetroChannel2"+"_"+ExtComplect+"_"+save,2,DoubleToStr(Fibo3*100,1));
       ObjectSetFiboDescription("MetroChannel2"+"_"+ExtComplect+"_"+save,3,DoubleToStr(Fibo4*100,1));
       ObjectSetFiboDescription("MetroChannel2"+"_"+ExtComplect+"_"+save,4,DoubleToStr(Fibo5*100,1));
       ObjectSetFiboDescription("MetroChannel2"+"_"+ExtComplect+"_"+save,5,DoubleToStr(Fibo6*100,1));
       ObjectSetFiboDescription("MetroChannel2"+"_"+ExtComplect+"_"+save,6,DoubleToStr(Fibo7*100,1));
       ObjectSetFiboDescription("MetroChannel2"+"_"+ExtComplect+"_"+save,7,DoubleToStr(Fibo8*100,1));
       ObjectSetFiboDescription("MetroChannel2"+"_"+ExtComplect+"_"+save,8,DoubleToStr(Fibo9*100,1));
       ObjectSetFiboDescription("MetroChannel2"+"_"+ExtComplect+"_"+save,9,DoubleToStr(Fibo10*100,1));
       ObjectSetFiboDescription("MetroChannel2"+"_"+ExtComplect+"_"+save,10,DoubleToStr(Fibo11*100,1));
       //ObjectSetFiboDescription("MetroChannel2"+"_"+ExtComplect+"_"+save,11,"-"+DoubleToStr(Fibo1*100,1));
       //ObjectSetFiboDescription("MetroChannel2"+"_"+ExtComplect+"_"+save,12,"-"+DoubleToStr(Fibo2*100,1));
       //ObjectSetFiboDescription("MetroChannel2"+"_"+ExtComplect+"_"+save,13,"-"+DoubleToStr(Fibo3*100,1));
       //ObjectSetFiboDescription("MetroChannel2"+"_"+ExtComplect+"_"+save,14,"-"+DoubleToStr(Fibo4*100,1));
       //ObjectSetFiboDescription("MetroChannel2"+"_"+ExtComplect+"_"+save,15,"-"+DoubleToStr(Fibo5*100,1));
       //ObjectSetFiboDescription("MetroChannel2"+"_"+ExtComplect+"_"+save,16,"-"+DoubleToStr(Fibo6*100,1));
       //ObjectSetFiboDescription("MetroChannel2"+"_"+ExtComplect+"_"+save,17,"-"+DoubleToStr(Fibo7*100,1));
       //ObjectSetFiboDescription("MetroChannel2"+"_"+ExtComplect+"_"+save,18,"-"+DoubleToStr(Fibo8*100,1));
       //ObjectSetFiboDescription("MetroChannel2"+"_"+ExtComplect+"_"+save,19,"-"+DoubleToStr(Fibo9*100,1));
       //ObjectSetFiboDescription("MetroChannel2"+"_"+ExtComplect+"_"+save,20,"-"+DoubleToStr(Fibo10*100,1));
       //ObjectSetFiboDescription("MetroChannel2"+"_"+ExtComplect+"_"+save,21,"-"+DoubleToStr(Fibo11*100,1));
     }
   }
   return(0);
  }
//+------------------------------------------------------------------+

double Scale()
{
   double priceRange = WindowPriceMax(0) - WindowPriceMin(0);
   double barsCount = WindowBarsPerChart();
   double chartScale = (priceRange / Point) / barsCount;
   return(chartScale*GPixels/VPixels);
}